"use strict";
exports.__esModule = true;
exports.clipboardCopy = void 0;
/**
 * Copies a text to the clipboard
 */
var clipboardCopy = function (text) {
    if (!navigator.clipboard) {
        var textArea = document.createElement('textarea');
        textArea.value = text;
        textArea.style.top = '0';
        textArea.style.left = '0';
        textArea.style.position = 'fixed';
        document.body.appendChild(textArea);
        textArea.focus();
        textArea.select();
        try {
            var successful = document.execCommand('copy');
            console.log('clipboardCopy', {
                type: 'Fallback',
                successful: successful
            });
        }
        catch (err) {
            console.log('clipboardCopy', {
                type: 'Fallback',
                successful: false
            });
        }
        document.body.removeChild(textArea);
        return;
    }
    navigator.clipboard.writeText(text).then(function () {
        console.log('clipboardCopy', {
            type: 'async',
            successful: true
        });
    })["catch"](function () {
        console.log('clipboardCopy', {
            type: 'async',
            successful: false
        });
    });
};
exports.clipboardCopy = clipboardCopy;
//# sourceMappingURL=clipboard.js.map