"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.clickablePath = void 0;
var lodash_1 = __importDefault(require("lodash"));
var index_1 = require("../index");
/**
 * Creates a clickable path (using anchors) from a path string
 */
var clickablePath = function (p) {
    var parts = (0, index_1.trimBoth)(p, '/').split('/');
    var built = '<a href="/">/</a>';
    parts.forEach(function (part, index) {
        if (!lodash_1["default"].isEmpty(part)) {
            built = (built + "<a href=\"/".concat(parts.slice(0, index + 1).join('/'), "\">").concat(((index + 1) !== 1 ? '/' : '')).concat(part, "</a>"));
        }
    });
    return built;
};
exports.clickablePath = clickablePath;
//# sourceMappingURL=clickablePath.js.map