"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.dirCollect = exports.dirFilter = exports.dirScan = void 0;
var path_1 = __importDefault(require("path"));
var fs_1 = require("fs");
var options_1 = require("../../../options");
var index_1 = require("../index");
var index_2 = require("./index");
var dirScan = function (path, opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var files, mappedFiles;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fs_1.promises.readdir(path)];
                case 1:
                    files = (_a.sent()).filter(function (file) {
                        if ((['.', '$'].includes(file[0]) || file.includes('#'))
                            && file !== '.indexignore') {
                            return false;
                        }
                        else {
                            return true;
                        }
                    });
                    mappedFiles = files.map(function (file) {
                        return {
                            basename: file,
                            extension: file.split('.').pop().toLowerCase()
                        };
                    });
                    /* Filter extensions if include is set */
                    if (opts.include
                        && Array.isArray(opts.include)
                        && opts.include.length > 0) {
                        mappedFiles = mappedFiles.filter(function (file) {
                            return (opts.include).includes(file.extension);
                        });
                    }
                    return [2 /*return*/, mappedFiles];
            }
        });
    });
};
exports.dirScan = dirScan;
/**
 * Collects the files (directory structure) from a directory
 */
var dirCollect = function (pathInfo, opts) {
    if (opts === void 0) { opts = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var data, files, extensions, exclude, _a, filter, offset, format;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = {
                        contents: {
                            files: [],
                            directories: []
                        },
                        stats: {
                            total: {
                                size: 0
                            },
                            newest: {
                                file: 0,
                                directory: 0
                            }
                        }
                    };
                    files = [];
                    extensions = options_1.options.get().media.extensions;
                    exclude = options_1.options.get('exclude');
                    _a = index_2.asyncForEach;
                    return [4 /*yield*/, dirScan(pathInfo.real)];
                case 1: return [4 /*yield*/, _a.apply(void 0, [_b.sent(), function (file) { return __awaiter(void 0, void 0, void 0, function () {
                            var stats, error_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, fs_1.promises.stat(path_1["default"].join(pathInfo.real, file.basename))];
                                    case 1:
                                        stats = _a.sent();
                                        files.push({
                                            basename: file.basename,
                                            extension: file.extension,
                                            directory: !stats.isFile() ? true : false,
                                            stats: stats
                                        });
                                        return [3 /*break*/, 3];
                                    case 2:
                                        error_1 = _a.sent();
                                        console.error(error_1);
                                        return [3 /*break*/, 3];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); }])];
                case 2:
                    _b.sent();
                    filter = options_1.options.get('filter');
                    filter.exclude = exclude;
                    /* Filter files if a filter is set */
                    if (filter.exclude
                        || filter.file
                        || filter.directory) {
                        files = dirFilter(files, filter);
                    }
                    offset = {
                        client: opts.timezone.offset
                    };
                    format = options_1.options.get('format');
                    /* Iterate over found files */
                    return [4 /*yield*/, (0, index_2.asyncForEach)(files, function (file) { return __awaiter(void 0, void 0, void 0, function () {
                            var type, modified, key, size, adjusted, formatted;
                            return __generator(this, function (_a) {
                                type = extensions.image.includes(file.extension)
                                    ? 0
                                    : (extensions.video.includes(file.extension)
                                        ? 1
                                        : null);
                                modified = Math.round(file.stats.mtimeMs / 1000);
                                key = (file.directory ? 'directory' : 'file');
                                if (modified > data.stats.newest[key]) {
                                    data.stats.newest[key] = modified;
                                }
                                size = {
                                    raw: (file.directory ? 0 : file.stats.size)
                                };
                                size.readable = (0, index_1.getReadableSize)(format.sizes, size.raw);
                                data.stats.total.size = (data.stats.total.size + size.raw);
                                adjusted = (0, index_1.calculateOffset)(offset.client, modified);
                                formatted = Array.isArray(options_1.options.get().format.date)
                                    ? [0, 1].map(function (i) { return (0, index_1.gmdate)(options_1.options.get().format.date[i], adjusted); })
                                    : Array(2).fill((0, index_1.gmdate)(options_1.options.get().format.date, adjusted));
                                data.contents[file.directory ? 'directories' : 'files'].push({
                                    media: (type === 0 || type === 1) ? true : false,
                                    type: type === 0 ? 'image' : (type === 1 ? 'video' : 'other'),
                                    hidden: false,
                                    relative: path_1["default"].join(pathInfo.relative, (file.basename)).replace(/\\/g, '/'),
                                    name: file.basename,
                                    size: size,
                                    modified: {
                                        raw: modified,
                                        formatted: formatted
                                    }
                                });
                                return [2 /*return*/];
                            });
                        }); })];
                case 3:
                    /* Iterate over found files */
                    _b.sent();
                    return [2 /*return*/, data];
            }
        });
    });
};
exports.dirCollect = dirCollect;
var dirFilter = function (files, filter) {
    return files.filter(function (file) {
        if (filter.exclude) {
            if ((filter.exclude).includes(file.extension)) {
                return false;
            }
        }
        if (filter.directory && file.directory) {
            return (file.basename).match(new RegExp(filter.directory));
        }
        else if (filter.file && !file.directory) {
            return (file.basename).match(new RegExp(filter.file));
        }
        return true;
    });
};
exports.dirFilter = dirFilter;
//# sourceMappingURL=dirUtils.js.map