"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var utils_1 = require("./utils");
var events_1 = require("./events");
var defaults = {
    delay: 75,
    encodeAll: false,
    cursor: true,
    force: null
};
var hoverPreview = /** @class */ (function () {
    function hoverPreview(element, options) {
        if (options === void 0) { options = {}; }
        if (!element) {
            throw Error('No element were passed.');
        }
        this.element = element;
        this.options = options;
        setup.call(this);
    }
    hoverPreview.prototype.reload = function () {
        this.destroy();
        setup.call(this);
    };
    hoverPreview.prototype.destroy = function () {
        var events = this.events;
        this.handle.removeEventListener('mouseenter', events.mouseenter, false);
        this.handle.removeEventListener('mouseleave', events.mouseleave, false);
        this.handle.removeEventListener('mousemove', events.mousemove, false);
    };
    return hoverPreview;
}());
function setup() {
    // set options and data
    this.options = __assign(__assign({}, defaults), this.options);
    this.data = {
        cursor: null,
        left: null,
        src: null,
        type: null,
        offset: null,
        dimensions: null,
        force: null
    };
    this.data.on = {};
    if (typeof this.options.on === 'object' && this.options.on !== null) {
        this.data.on = this.options.on;
    }
    if (this.options.force) {
        this.data.force = this.options.force;
    }
    this.timers = {
        load: null,
        delay: null
    };
    // set handle
    this.handle = this.element;
    // move function
    this.updater = (0, utils_1.getMove)();
    this.events = {
        mouseenter: events_1.mouseenter.bind(this),
        mouseleave: events_1.mouseleave.bind(this),
        mousemove: events_1.mousemove.bind(this)
    };
    this.active = false;
    this.id = 0;
    // add events
    this.handle.addEventListener('mouseleave', this.events.mouseleave, false);
    this.handle.addEventListener('mouseenter', this.events.mouseenter, false);
    this.handle.addEventListener('mousemove', this.events.mousemove, false);
}
// export default
exports["default"] = (function (element, options) { return new hoverPreview(element, options); });
//# sourceMappingURL=hover-preview.js.map