"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/** Vendors */
var lodash_1 = __importDefault(require("lodash"));
var express_1 = __importDefault(require("express"));
var cookie_parser_1 = __importDefault(require("cookie-parser"));
var compression_1 = __importDefault(require("compression"));
var showdown_1 = __importDefault(require("showdown"));
var path_1 = __importDefault(require("path"));
var express_basic_auth_1 = __importDefault(require("express-basic-auth"));
var https_1 = __importDefault(require("https"));
var chalk_1 = __importDefault(require("chalk"));
/** Vendors */
var fs_1 = require("fs");
/** Modules */
var options_1 = require("./options");
/** Helpers */
var helpers_1 = require("./core/helpers/");
/** Helpers */
var node_1 = require("./core/helpers/node/");
/** Markdown converter */
var converter = new showdown_1["default"].Converter();
/** Express server */
var app = (0, express_1["default"])();
/** Config storage */
var config = {
    clientTemplate: {},
    server: options_1.options.get()
};
/** Handles any incoming requests */
var handle = function (directory, req, res, next, executed) {
    if (executed === void 0) { executed = null; }
    return __awaiter(void 0, void 0, void 0, function () {
        var relative, requested_1, stat, validated, client, clientConfig, data, readmeContent_1, readme, ignore, fileObject_1, raw, variables, processor, exclude, sent, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 12, , 13]);
                    relative = decodeURIComponent(req.path);
                    return [4 /*yield*/, fs_1.promises.realpath(path_1["default"].join(directory, relative))];
                case 1:
                    requested_1 = _a.sent();
                    return [4 /*yield*/, fs_1.promises.lstat(requested_1)];
                case 2:
                    stat = _a.sent();
                    validated = (0, node_1.isAbovePath)((0, helpers_1.trimRight)(directory, '/'), requested_1.replace(/\\/g, '/'));
                    if (!validated) {
                        throw new Error(chalk_1["default"].red('Directory request could not be validated.'));
                    }
                    if (!(validated && stat.isDirectory())) return [3 /*break*/, 10];
                    if (options_1.options.get('debug')) {
                        (0, node_1.logger)('debug', chalk_1["default"].yellow("Navigating: ".concat(chalk_1["default"].green("'".concat(relative, "'")), " ...")));
                    }
                    client = (0, node_1.cookieRead)(req);
                    clientConfig = (0, node_1.configAdjust)(config.clientTemplate, client);
                    /** Create a UTC timestamp for the client sided scripts to work with */
                    clientConfig.timestamp = (0, helpers_1.calculateOffset)(0);
                    return [4 /*yield*/, (0, node_1.dirCollect)({
                            real: requested_1,
                            relative: relative
                        }, {
                            timezone: {
                                offset: client.timezoneOffset ? (client.timezoneOffset * 60) : 0
                            }
                        })];
                case 3:
                    data = _a.sent();
                    /** Set performance mode */
                    clientConfig.performance = (clientConfig.performance !== false
                        && clientConfig.performance !== 0
                        && clientConfig.performance !== null)
                        ? (data.contents.files.length >= clientConfig.performance)
                        : false;
                    readmeContent_1 = null;
                    if (!config.server.readme.enabled) return [3 /*break*/, 6];
                    return [4 /*yield*/, data.contents.files.find(function (file) { return file.name === 'README.md'; })];
                case 4:
                    readme = _a.sent();
                    if (!readme) return [3 /*break*/, 6];
                    /** Read `README.md` file */
                    return [4 /*yield*/, fs_1.promises.readFile(path_1["default"].join(directory, readme.relative), 'utf8').then(function (fileBuffer) {
                            readmeContent_1 = converter.makeHtml(fileBuffer.toString());
                        })];
                case 5:
                    /** Read `README.md` file */
                    _a.sent();
                    /** Set hidden state if enabled */
                    readme.hidden = config.server.readme.hidden ? true : false;
                    _a.label = 6;
                case 6: return [4 /*yield*/, data.contents.files.find(function (file) { return file.name === '.indexignore'; })];
                case 7:
                    ignore = _a.sent();
                    if (!ignore) return [3 /*break*/, 9];
                    fileObject_1 = {};
                    /** Get all files and directories */
                    (data.contents.files).forEach(function (file) { return fileObject_1[file.name] = file; });
                    (data.contents.directories).forEach(function (file) { return fileObject_1[file.name + '/'] = file; });
                    /** Read `.indexignore` file */
                    return [4 /*yield*/, fs_1.promises.readFile(path_1["default"].join(directory, ignore.relative), 'utf8').then(function (fileBuffer) {
                            /** Split `.indexignore` by new line */
                            var ignoredFiles = fileBuffer.toString().split(/\r?\n/);
                            var _loop_1 = function (i) {
                                var input = ignoredFiles[i];
                                /** Break on empty input */
                                if (!input || input.length === 0) {
                                    return "break";
                                }
                                if (Object.prototype.hasOwnProperty.call(fileObject_1, input)) {
                                    fileObject_1[input].hidden = true;
                                }
                                else if (input.includes('*')) {
                                    /** Escape input and create new regular expression */
                                    var regex_1 = (0, node_1.wildcardExpression)(input);
                                    /** Check file/directory names, match against expression - hide on match */
                                    Object.keys(fileObject_1).forEach(function (key) {
                                        if (regex_1.test(key)) {
                                            fileObject_1[key].hidden = true;
                                        }
                                    });
                                }
                            };
                            /** Iterate over `.indexignore` entries */
                            for (var i = 0; i < ignoredFiles.length; i++) {
                                var state_1 = _loop_1(i);
                                if (state_1 === "break")
                                    break;
                            }
                        })];
                case 8:
                    /** Read `.indexignore` file */
                    _a.sent();
                    ignore.hidden = true;
                    _a.label = 9;
                case 9:
                    raw = ['size', 'modified'].includes(clientConfig.sorting.sortBy) ? true : false;
                    /** Apply file sorting */
                    if (clientConfig.sorting.types === 0 || clientConfig.sorting.types === 1) {
                        (0, node_1.sortByKey)(data.contents.files, "".concat(clientConfig.sorting.sortBy).concat(raw ? '.raw' : ''), clientConfig.sorting.order);
                    }
                    /** Apply directory sorting */
                    if (clientConfig.sorting.types === 0 || clientConfig.sorting.types === 2) {
                        (0, node_1.sortByKey)(data.contents.directories, "".concat(clientConfig.sorting.sortBy).concat(raw ? '.raw' : ''), clientConfig.sorting.order);
                    }
                    /** Trim the relative path (request uri) */
                    relative = (relative !== '/' ? (0, helpers_1.trimRight)(relative, '/').replace(/([^:]\/)\/+/g, '$1') : relative);
                    variables = {
                        config: clientConfig,
                        contents: data.contents,
                        path: (0, node_1.clickablePath)(relative),
                        readme: {
                            content: readmeContent_1,
                            toggled: !clientConfig.readme.toggled
                        },
                        req: relative,
                        parent: (0, helpers_1.addLeading)(relative.substring(0, relative.lastIndexOf('/')), '/'),
                        count: {
                            files: data.contents.files.length,
                            directories: data.contents.directories.length
                        },
                        stats: {
                            total: {
                                size: (0, helpers_1.getReadableSize)(options_1.options.get('format.sizes'), data.stats.total.size)
                            },
                            newest: data.stats.newest
                        },
                        rendered: (0, node_1.getExecutionTime)(process.hrtime(executed))
                    };
                    processor = options_1.options.get('processor');
                    /** Render the page. Variables are passed to views/index.pug */
                    res.render('index', processor ? processor(variables) : variables);
                    return [3 /*break*/, 11];
                case 10:
                    if (validated && stat.isFile()) {
                        exclude = options_1.options.get('exclude');
                        sent = false;
                        if (Array.isArray(exclude)) {
                            if (exclude.includes(requested_1.split('.').pop().toLowerCase())) {
                                /** Extension is excluded, show an error */
                                res.status(404).render('errors/404');
                                sent = true;
                            }
                        }
                        if (!sent) {
                            if (options_1.options.get('debug')) {
                                (0, node_1.logger)('debug', chalk_1["default"].yellow("Serving: ".concat(chalk_1["default"].cyan("'".concat(relative, "'")), " ...")));
                            }
                            /** Request is a valid file, attempt to display it */
                            res.sendFile(requested_1, function (error) {
                                if (error) {
                                    if (options_1.options.get('debug')) {
                                        (0, node_1.logger)('debug', chalk_1["default"].red("Encountered an error when serving file ".concat(chalk_1["default"].cyan("'".concat(requested_1, "'")), ": ").concat(error)));
                                    }
                                    res.status(500).end();
                                    next();
                                }
                            });
                        }
                    }
                    else {
                        res.status(400).render('errors/400');
                    }
                    _a.label = 11;
                case 11: return [3 /*break*/, 13];
                case 12:
                    e_1 = _a.sent();
                    (0, node_1.logger)('error', chalk_1["default"].red('error'), e_1);
                    if (e_1.code === 'ENOENT') {
                        /** Path does not exist on the server side */
                        res.status(404).render('errors/404');
                    }
                    else {
                        /** Any non-ENOENT (404) error */
                        res.status(400).render('errors/400', {
                            code: e_1.code
                        });
                    }
                    next();
                    return [3 /*break*/, 13];
                case 13: return [2 /*return*/];
            }
        });
    });
};
var ivfi = function (workingDirectory) {
    if (workingDirectory === void 0) { workingDirectory = path_1["default"].join(__dirname, '..'); }
    /** Set view engine and path */
    app
        .set('view engine', 'pug')
        .set('views', path_1["default"].join(workingDirectory, 'views'));
    /** Enable cookie reader and gzip compression */
    app
        .use((0, cookie_parser_1["default"])())
        .use((0, compression_1["default"])());
    var module = {
        /**
         * Module variables
         */
        server: null,
        directory: null,
        port: null,
        /**
         * Server instance getter
         */
        get: function () {
            return module.server;
        },
        /**
         * Changes the directory of the server
         */
        "switch": function (directory) {
            var setDir = directory.replace(/\\/g, '/');
            (0, node_1.logger)('info', chalk_1["default"].yellow("Switching root directory to: ".concat(chalk_1["default"].green("'".concat(setDir, "'")))));
            return module.directory = setDir;
        },
        /**
         * Starts the server
         */
        start: function (callback) {
            if (callback === void 0) { callback = function () { }; }
            return __awaiter(void 0, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            (0, node_1.logger)('info', chalk_1["default"].green('Starting server ...'));
                            return [4 /*yield*/, module.server.listen(module.port, callback(module.server))];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        },
        /**
         * Stops the server
         */
        stop: function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        (0, node_1.logger)('info', chalk_1["default"].red('Stopping server ...'));
                        return [4 /*yield*/, module.server.close()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); },
        /**
         * Initiates and starts the server
         */
        run: function (port /** Port to expose the web server on */, directory /** Root working directory */, opts) {
            if (port === void 0) { port = 80; }
            if (directory === void 0) { directory = workingDirectory; }
            if (opts === void 0) { opts = {}; }
            return __awaiter(void 0, void 0, void 0, function () {
                var e_2, location_1, pool, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            /** Store/set port and directory */
                            module.port = port;
                            module.directory = path_1["default"].resolve(directory).replace(/\\/g, '/');
                            /** Merge set config with defaults */
                            options_1.options.set(opts);
                            if (options_1.options.get('debug')) {
                                /** Print some debugging information */
                                (0, node_1.logger)('debug', chalk_1["default"].yellow('Debugging is enabled.'));
                                (0, node_1.logger)('debug', chalk_1["default"].yellow("Using options: ".concat(chalk_1["default"].gray(JSON.stringify(opts)))));
                                (0, node_1.logger)('debug', chalk_1["default"].yellow("Root directory is set to: ".concat(chalk_1["default"].green("'".concat(directory, "'")))));
                            }
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 3, , 4]);
                            /** Checks if /dist/ exists */
                            return [4 /*yield*/, fs_1.promises.realpath(path_1["default"].join(workingDirectory, 'dist'))];
                        case 2:
                            /** Checks if /dist/ exists */
                            _b.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_2 = _b.sent();
                            if (e_2.code === 'ENOENT') {
                                /** /dist/ does not exist */
                                (0, node_1.logger)('info', chalk_1["default"].yellow('Compiled directories were not found. Try running "npm run compile" to build the required files.'));
                            }
                            else {
                                (0, node_1.logger)('error', chalk_1["default"].red(e_2));
                            }
                            process.exit(0);
                            return [3 /*break*/, 4];
                        case 4:
                            /** Set authentication */
                            if (lodash_1["default"].has(opts, 'authentication.users') && opts.authentication.users) {
                                app.use((0, express_basic_auth_1["default"])({
                                    users: opts.authentication.users,
                                    challenge: true
                                }));
                            }
                            /** Set public directory */
                            app.use(express_1["default"].static("".concat(workingDirectory, "/dist/")));
                            if (!(lodash_1["default"].has(opts, 'style.themes.path') && lodash_1["default"].isObject(opts.style.themes))) return [3 /*break*/, 6];
                            location_1 = opts.style.themes.path;
                            return [4 /*yield*/, (0, node_1.loadThemes)(opts.style.themes.path)];
                        case 5:
                            pool = _b.sent();
                            if (pool) {
                                if (options_1.options.get('debug')) {
                                    (0, node_1.logger)('debug', chalk_1["default"].yellow("Loaded ".concat(Object.keys(pool).length, " theme(s)")));
                                }
                                options_1.options.insert('style.themes', {
                                    path: '/themes/',
                                    pool: pool,
                                    /** Get default theme if set, also check if it exists in pool */
                                    set: lodash_1["default"].has(opts, 'style.themes.default')
                                        ? (pool[opts.style.themes["default"].toLowerCase()]
                                            ? opts.style.themes["default"].toLowerCase()
                                            : null)
                                        : null
                                });
                                /** Serve themes files through /themes/ */
                                app.use('/themes/', express_1["default"].static(location_1));
                            }
                            else {
                                /** No themes were found, disable themes */
                                options_1.options.insert('style.themes', false);
                            }
                            _b.label = 6;
                        case 6:
                            /** Handle any incoming requests */
                            app.get('(/*)?', function (req, res, next) {
                                handle(module.directory, req, res, next, process.hrtime());
                            });
                            /** Set http or https (if options.ssl is set) server */
                            module.server = (lodash_1["default"].has(opts, 'ssl') && lodash_1["default"].isObject(opts.ssl) ? https_1["default"].createServer(opts.ssl, app) : app);
                            /** Create client config template */
                            config.clientTemplate = (0, node_1.configCreate)(config.server, options_1.options.get());
                            /** Bind to port and listen for requests */
                            _a = module;
                            return [4 /*yield*/, module.server.listen(module.port, function () { return __awaiter(void 0, void 0, void 0, function () {
                                    var listenUrl;
                                    return __generator(this, function (_a) {
                                        listenUrl = "http".concat(lodash_1["default"].has(opts, 'ssl') ? 's' : '', "://localhost:").concat(module.port);
                                        (0, node_1.logger)('info', "Listening on ".concat(chalk_1["default"].green(listenUrl), " ..."));
                                        return [2 /*return*/];
                                    });
                                }); })];
                        case 7:
                            /** Bind to port and listen for requests */
                            _a.server = _b.sent();
                            return [2 /*return*/, module];
                    }
                });
            });
        }
    };
    return module;
};
exports["default"] = ivfi;
//# sourceMappingURL=index.js.map